/****************************************************************************
*  Target Script for the i.MX 6UltraLite EVK Board.
*  
*  The DDR init code is based on the SEGGER J-Link script "ddr_init.jlinkscript"
*  from the i.MX 6UltraLite SDK "SDK_2.2_MCIM6UL". 
****************************************************************************/

function ClockInit()
{
   // Enable all clocks
   TargetInterface.pokeWord(0x020c4068,0xffffffff);
   TargetInterface.pokeWord(0x020c406c,0xffffffff);
   TargetInterface.pokeWord(0x020c4070,0xffffffff);
   TargetInterface.pokeWord(0x020c4074,0xffffffff);
   TargetInterface.pokeWord(0x020c4078,0xffffffff);
   TargetInterface.pokeWord(0x020c407c,0xffffffff);
   TargetInterface.pokeWord(0x020c4080,0xffffffff);
}

function DDRInit()
{
   // Config IOMUX for ddr
   TargetInterface.pokeWord(0x020E04B4,0x000C0000);
   TargetInterface.pokeWord(0x020E04AC,0x00000000);
   TargetInterface.pokeWord(0x020E027C,0x00000030);
   TargetInterface.pokeWord(0x020E0250,0x00000030);
   TargetInterface.pokeWord(0x020E024C,0x00000030);
   TargetInterface.pokeWord(0x020E0490,0x00000030);
   TargetInterface.pokeWord(0x020E0288,0x00000030);
   TargetInterface.pokeWord(0x020E0270,0x00000000);
   TargetInterface.pokeWord(0x020E0260,0x00000030);
   TargetInterface.pokeWord(0x020E0264,0x00000030);
   TargetInterface.pokeWord(0x020E04A0,0x00000030);
   TargetInterface.pokeWord(0x020E0494,0x00020000);
   TargetInterface.pokeWord(0x020E0280,0x00000030);
   TargetInterface.pokeWord(0x020E0284,0x00000030);
   TargetInterface.pokeWord(0x020E04B0,0x00020000);
   TargetInterface.pokeWord(0x020E0498,0x00000030);
   TargetInterface.pokeWord(0x020E04A4,0x00000030);
   TargetInterface.pokeWord(0x020E0244,0x00000030);
   TargetInterface.pokeWord(0x020E0248,0x00000030);
  
   // Config DDR Controller Registers
   TargetInterface.pokeWord(0x021B001C,0x00008000);
   TargetInterface.pokeWord(0x021B0800,0xA1390003);
   TargetInterface.pokeWord(0x021B080C,0x00000000);
   TargetInterface.pokeWord(0x021B083C,0x41570155);
   TargetInterface.pokeWord(0x021B0848,0x4040474A);
   TargetInterface.pokeWord(0x021B0850,0x40405550);
   TargetInterface.pokeWord(0x021B081C,0x33333333);
   TargetInterface.pokeWord(0x021B0820,0x33333333);
   TargetInterface.pokeWord(0x021B082C,0xf3333333);
   TargetInterface.pokeWord(0x021B0830,0xf3333333);
   TargetInterface.pokeWord(0x021B08C0,0x00921012);
   TargetInterface.pokeWord(0x021B08b8,0x00000800);

   // Config MMDC init
   TargetInterface.pokeWord(0x021B0004,0x0002002D);
   TargetInterface.pokeWord(0x021B0008,0x1B333030);
   TargetInterface.pokeWord(0x021B000C,0x676B52F3);
   TargetInterface.pokeWord(0x021B0010,0xB66D0B63);
   TargetInterface.pokeWord(0x021B0014,0x01FF00DB);
   TargetInterface.pokeWord(0x021B0018,0x00201740);
   TargetInterface.pokeWord(0x021B001C,0x00008000);
   TargetInterface.pokeWord(0x021B002C,0x000026D2);
   TargetInterface.pokeWord(0x021B0030,0x006B1023);
   TargetInterface.pokeWord(0x021B0040,0x0000004F);
   TargetInterface.pokeWord(0x021B0000,0x84180000);
   TargetInterface.pokeWord(0x021B0890,0x23400A38);	//???
   TargetInterface.pokeWord(0x021B001C,0x02008032);
   TargetInterface.pokeWord(0x021B001C,0x00008033);
   TargetInterface.pokeWord(0x021B001C,0x00048031);
   TargetInterface.pokeWord(0x021B001C,0x15208030);
   TargetInterface.pokeWord(0x021B001C,0x04008040);
   TargetInterface.pokeWord(0x021B0020,0x00000800);
   TargetInterface.pokeWord(0x021B0818,0x00000227);
   TargetInterface.pokeWord(0x021B0004,0x0002552D);
   TargetInterface.pokeWord(0x021B0404,0x00011006);
   TargetInterface.pokeWord(0x021B001C,0x00000000);
}

function Reset() {
   TargetInterface.resetAndStop();
   
   if (0 == (TargetInterface.peekWord(0x021B0000) & 0x80000000))
   {
      ClockInit();
      DDRInit();
   }
}

function EnableTrace(traceInterfaceType) {
  // TODO: Enable trace
}

/*** EOF ***/
